(custom-set-variables
  ;; custom-set-variables was added by Custom -- don't edit or cut/paste it!
  ;; Your init file should contain only one such instance.
 '(c-default-style (quote ((c-mode . "linux") (c++-mode . "stroustrup") (java-mode . "java") (other . "gnu"))))
 '(case-fold-search t)
 '(column-number-mode t)
 '(current-language-environment "ASCII")
 '(global-font-lock-mode t nil (font-lock))
 '(indent-tabs-mode nil)
 '(php-mode-force-pear t)
 '(show-paren-mode t nil (paren))
 '(text-mode-hook (quote (turn-on-auto-fill text-mode-hook-identify)))
 '(timeclock-file "~/.timeclock/default.log")
 '(timeclock-multiple-jobs t)
 '(transient-mark-mode t)
 '(diary-file "~/.diary")
 '(user-mail-address "rjk@wormbytes.ca"))

;; (custom-set-faces
;;   ;; custom-set-faces was added by Custom -- don't edit or cut/paste it!
;;   ;; Your init file should contain only one such instance.
;;  '(font-lock-comment-face ((((class color) (background light)) (:foreground "Firebrick"))))
;;  '(font-lock-function-name-face ((((class color) (background light)) (:foreground "Blue"))))
;;  '(font-lock-keyword-face ((((class color) (background light)) (:foreground "RoyalBlue"))))
;;  '(font-lock-reference-face ((((class color) (background light)) (:foreground "Purple"))))
;;  '(font-lock-string-face ((((class color) (background light)) (:foreground "SpringGreen4"))))
;;  '(font-lock-type-face ((((class color) (background light)) (:foreground "DarkGoldenRod"))))
;;  '(font-lock-variable-name-face ((((class color) (background light)) (:foreground "GoldenRod"))))
;;  '(mode-line ((((type x w32 mac) (class color)) (:background "grey75" :foreground "black" :box (:line-width -1 :style released-button) :height 0.8)))))

(custom-set-faces
  ;; custom-set-faces was added by Custom -- don't edit or cut/paste it!
  ;; Your init file should contain only one such instance.
 '(font-lock-comment-face ((((class color) (background dark)) (:foreground "Orange"))))
 '(mode-line ((((type x w32 mac) (class color)) (:background "rgb:29/45/45" :foreground "rgb:f5/de/b3" :box (:line-width -1 :style released-button))))))


;;
;; Update the load-path to include the directory where my local
;; definitions are stored.
;;
(setq load-path (append '("/usr/local/share/emacs/site-lisp/"
			  "~/.emacs.d"
			  "~/.emacs.d/tramp"
			  ) load-path))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Load up the various modules used to configure my Emacs experience
;;
(require 'calendar)
(require 'planner-config)
(require 'timeclock)
(require 'psvn) ; SVN VC support
(require 'tramp) ; remote SSH editing support
(require 'pic-asm-mode)
(require 'javascript-mode)
(require 'cl) ; required for "lexical-let" macro
(require 'mercurial)

(load "debian-ispell")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Define global variables used to customize Emacs.
;;

;; Set the information for the Canadian dictionary
(debian-ispell-add-dictionary-entry
 '("canadian"
   "[A-Za-z]"
   "[^A-Za-z]"
   "[']"
   nil
   ("-B" "-d" "canadian")
   nil
   iso-8859-1)
 "canadian")

;; Set the default "diff" switch to be unified diffs
(setq diff-switches "-u")

;; Define myself in the ORGANIZATION environment variable.  This variable
;; is used by the copyright function to write my copyright notice.
(setenv "ORGANIZATION" (concat user-full-name " <" user-mail-address ">"))

;; Define various jobs for the timeclock-x module (not currently used)
;(setq timeclock-job-list '("default" "sidx" "dcbs" "canvil" "health"))

;; Make point more likely to return to where it had been after several
;; scroll operation. (Charles Curley)
(setq scroll-preserve-screen-position t)

;; Bring in the remote access system
(setq auto-save-file-name-transforms
      '(("\\`/[^/]*:\\(.+/\\)*\\(.*\\)" "/home/rjkaes/.autosave/\\2")))

;; Set my home co-ordinates for sunrise/sunset calculations
(setq calendar-latitude [42 50 north])
(setq calendar-longitude [80 18 west])
(setq calendar-location-name "Simcoe, Ont")



;; Whenever perl-mode is called for, use cperl-mode
(autoload 'perl-mode "cperl-mode" "alternate mode for editing Perl programs" t)

;; Use cperl mode if perl is in the #!
(setq interpreter-mode-alist
      (append interpreter-mode-alist '(("miniperl" . perl-mode))))

;;
;; Define which modules should be used for various types of files.
;; Anytime a new file type needs to be accessed, this alist should
;; be updated.
;;
(setq auto-mode-alist
      (append '(("/eng/tools/gputils/.*\\.[ch]$" . gputils-mode)
                ("\\.C$" . c++-mode)
		("\\.cc$" . c++-mode)
                ("\\.hh$" . c++-mode)
                ("\\.c$" . c-mode)
                ("\\.h$" . c-mode)
                ("\\.\\([pP][Llm]\\|al\\)$" . cperl-mode)
                ("\\.css$" . css-mode)
                ("\\.ac$" . autoconf-mode)
                ("\\.js$" . javascript-mode)
                ) auto-mode-alist))






;;
;; Now define my own copyright routine.  It uses the standard copyright
;; function, but then adds the "All rights reserved." line below it.
;;
(define-skeleton insert-my-copyright
  "Define my own copyright system"
  (interactive)

  ;; Insert the main copyright string
  comment-start
  (delete-horizontal-space)
  " Copyright (C) " (format-time-string "%Y") " by " (getenv "ORGANIZATION")
  (newline)
  comment-start
  (delete-horizontal-space)
  "   All rights reserved."
  comment-end
  (newline))

;; Configure the F9 key to add my copyright notice
(global-set-key [f9] 'insert-my-copyright)

;;
;; Define a hotkey to generate the current date/time in
;; T-combined format.
;;
(define-skeleton datetime-in-t-format
  "Return the current date/time in T-combined format"
  (interactive)
  (format-time-string "%Y%m%dT%H%M%S"))
(global-set-key [?\C-c ?\C-w] 'datetime-in-t-format)


;;;;;;;;;;
;;
;;  Set up various mode hooks
;;
(add-hook 'change-log-mode-hook 'turn-on-auto-fill)
(add-hook 'text-mode-hook 'turn-on-auto-fill)

;;;;;;;;;;
;;
;; Include support for the Subversion source management system
;;
;(add-to-list 'vc-handled-backends 'SVN)
;(add-hook 'svn-log-edit-mode-hook 'turn-on-auto-fill)


;;
;; Bring in the timeclock to help me keep track of the number of hours
;; I've worked on various projects.
;;
;; NOTE: This _must_ be loaded before an calendar information.
;;
;(defun initialize-our-timeclock ()
;  "Setup all the fields for starting the timeclock module"
;  (load "timeclock-x")
;  (timeclock-modeline-display 1)
;  (timeclock-setup-keys))
(defun initialize-our-timeclock ()
  (timeclock-modeline-display 1)
  (setq timeclock-relative nil)
  )



;;;;;;;;;;
;;
;;  Map key sequences to various actions
;;

;; Configure F3 to bring up the scratch buffer in the current window
(defun switch-to-scratch-buffer ()
  "Switch the current window to the *scratch* buffer"
  (interactive)
  (switch-to-buffer "*scratch*" t))
(global-set-key [f3] 'switch-to-scratch-buffer)

;; Configure the F8 key to add an entry to the ChangeLog file
(global-set-key [f8] 'add-change-log-entry)

;; Change a few keys in the text major mode to make text editing more
;; convient
(define-key text-mode-map "\t" 'tab-to-tab-stop)
(define-key text-mode-map "\C-l" 'ispell)
(define-key text-mode-map "\M-Q" 'fill-region)


(defun switch-to-scratch-buffer ()
  (interactive)
  (switch-to-buffer "*scratch*" t))




;;
;; Set up some basic information that is common to all my emacs
;; locations.
;;
(display-time)


;; Set up the colour, frame size, and font for the emacs windows
(if window-system
    (progn
      ;; Make sure the delete key works correctly
      (normal-erase-is-backspace-mode 1)
      
      ;; Start the emacs server
      (server-start)

      ;; Load and start the timeclock modules
      (initialize-our-timeclock)
      
      ;; Set the frame's title. %b is the name of the buffer. %+ indicates
      ;; the state of the buffer: * if modified, % if read only, or -
      ;; otherwise. Two of them to emulate the mode line. %f for the file
      ;; name. Incredibly useful!
      (setq frame-title-format "Emacs: %b %+%+ %f")

      ;; Turn off the tool-bar
      (tool-bar-mode nil)
      ))

;; Always have the mini-buffer the appropriate size.  Useful for long file
;; names, etc.  Courtesy of "Dr. Francis J. Wright" <F.J.Wright@qmw.ac.uk>
(resize-minibuffer-mode)



;;;;;;;;;;
;;
;; Display the number of lines, words, and characters in the selected region
;;
(defun wc-region nil
  "Display the number of lines, words, and characters in the selected region"
  (interactive)
  (shell-command-on-region (mark) (- (point) 1) "wc"))



;;---------------------------------------------------------------
;;
;; Define the various modes to load based on the file extension
;;

(defun gputils-mode ()
  (message "Loading gputils-mode...")
  (c-mode)
  (c-set-style "gnu"))




;; Set the style for the Perl mode
(add-hook 'cperl-mode-hook
          #'(lambda () (cperl-set-style "PerlStyle")))



;;;
;;; Turn on reindent-then-newline-and-indent for the following modes.
;;;
(setq redefined-modes '((cperl-mode-hook . cperl-mode-map)
                        (c-mode-hook . c-mode-map)
                        (c++-mode-hook . c++-mode-map)
                        (lisp-mode-hook . lisp-mode-map)
                        (emacs-lisp-mode-hook . emacs-lisp-mode-map)
                        (javascript-mode-hook . javascript-mode-map)
                        (php-mode-user-hook . php-mode-map)))

;; For each mode, add a hook to redefine the return key

(dolist (mode redefined-modes)
  (lexical-let ((hook (car mode))
                (map (cdr mode)))
    (add-hook hook
              #'(lambda ()
                  (define-key (eval map) (kbd "<RET>")
                    'reindent-then-newline-and-indent)))))


;;;
;;; Set up the forth environment
;;;
(autoload 'forth-mode "gforth.el")
(setq auto-mode-alist (cons '("\\.fs?\\'" . forth-mode)
			    auto-mode-alist))
(autoload 'forth-block-mode "gforth.el")
(setq auto-mode-alist (cons '("\\.fb\\'" . forth-block-mode)
			    auto-mode-alist))
(add-hook 'forth-mode-hook (function (lambda ()
   ;; customize variables here:
   (setq forth-indent-level 3)
   (setq forth-minor-indent-level 1)
   (setq forth-hilight-level 3)
   ;;; ...
)))


;;
;; Finally show the day's plan file (from planner) and display the
;; calendar at the bottom of the screen.
;;

(if window-system
    (progn
      ;; Add the appointment generator to the diary hook.  Then set a
      ;; vector for the number of days in advance to show appointments.
      ;; Then turn the diary mode on.
      (setq number-of-diary-entries [2 3 3 3 3 5 2])
      (add-hook 'diary-hook 'appt-make-list)
      (add-hook 'diary-display-hook 'fancy-diary-display)
      ;; If this is non-nil, Emacs rings the terminal bell for
      ;; appointment reminders.  The default is t.
      (setq appt-audible nil)

      ;; Display the appointments in another window
      (setq appt-msg-window t)

      ;; Show the calendar
      (calendar)                       ; fire up the calendar display.
      (mark-diary-entries)
      (enlarge-window (- 11 (window-height)))

      (select-window (get-largest-window))
      (plan 3)
	
      ))
